> ## Documentation Index
> Fetch the complete documentation index at: https://guide.withvayu.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Measurement

> Create a new Measurement.



## OpenAPI

````yaml post /measurements
openapi: 3.0.0
info:
  title: Vayu API
  version: 1.0.0
  description: >-
    The Vayu API is a RESTful API that allows you to submit events for
    processing and storage & manage billing related entities.
              The API is secured using the Bearer Authentication scheme with JWT tokens.
              To obtain a JWT token, please contact Vayu at team@withvayu.com
  contact:
    email: dev@withvayu.com
    name: Vayu, Inc
    url: https://withvayu.com
servers:
  - url: https://connect.withvayu.com
    description: Production server
  - url: https://staging-connect.withvayu.com
    description: Sandbox server
security: []
tags:
  - name: auth
    description: >-
      The auth tag is used for endpoints related to authentication and
      authorization.
  - name: events
    description: The events tag is used for endpoints related to event ingestion.
  - name: customers
    description: The customers tag is used for endpoints related to customer management.
  - name: meters
    description: The meters tag is used for endpoints related to meter management.
  - name: contracts
    description: The contracts tag is used for endpoints related to contract management.
  - name: invoices
    description: The invoices tag is used for endpoints related to invoice management.
  - name: credits
    description: The credits tag is used for endpoints related to credit management.
  - name: webhooks
    description: The webhooks tag is used for endpoints related to webhook management.
paths:
  /measurements:
    post:
      tags:
        - measurements
      summary: Create Measurement
      description: Create a new Measurement.
      operationId: createMeasurement
      requestBody:
        $ref: '#/components/requestBodies/CreateMeasurementRequest'
      responses:
        '200':
          $ref: '#/components/responses/CreateMeasurementResponse'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ValidationErrorResponse'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthorizedErrorResponse'
        '429':
          description: Too Many Requests
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RateLimitErrorResponse'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InternalServerErrorResponse'
      security:
        - BearerAuthorizer: []
components:
  requestBodies:
    CreateMeasurementRequest:
      required: true
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/CreateMeasurementRequest'
  responses:
    CreateMeasurementResponse:
      description: RequestSuccess
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/CreateMeasurementResponse'
  schemas:
    ValidationErrorResponse:
      type: object
      properties:
        type:
          type: string
          enum:
            - invalid_request_error
        code:
          type: string
          description: Specific machine-readable error code
        message:
          type: string
          description: Human-readable error explanation
        param:
          type: string
          description: Single parameter that failed validation
        params:
          type: array
          items:
            type: object
            properties:
              param:
                type: string
                description: The parameter that failed validation
              message:
                type: string
                description: Why validation failed for this parameter
            required:
              - param
              - message
          description: Multiple parameters that failed validation
      required:
        - type
        - code
        - message
    UnauthorizedErrorResponse:
      type: object
      properties:
        type:
          type: string
          enum:
            - authentication_error
        code:
          type: string
          enum:
            - authentication_failed
        message:
          type: string
          description: Human-readable error explanation
      required:
        - type
        - code
        - message
    RateLimitErrorResponse:
      type: object
      properties:
        type:
          type: string
          enum:
            - rate_limit_error
        code:
          type: string
          enum:
            - rate_limit_exceeded
        message:
          type: string
          description: Human-readable error explanation
      required:
        - type
        - code
        - message
    InternalServerErrorResponse:
      type: object
      properties:
        type:
          type: string
          enum:
            - api_error
        code:
          type: string
          enum:
            - internal_error
        message:
          type: string
          description: Human-readable error explanation
      required:
        - type
        - code
        - message
    CreateMeasurementRequest:
      type: object
      properties:
        customerId:
          type: string
          pattern: ^[0-9a-fA-F]{24}$
          description: The customer for whom usage will be attributed
        meterId:
          type: string
          pattern: ^[0-9a-fA-F]{24}$
          description: The meter/product that is being measured
        usageDate:
          type: object
          properties:
            year:
              type: integer
              minimum: 0
            month:
              type: integer
              minimum: 0
              maximum: 12
            day:
              type: integer
              minimum: 1
              maximum: 31
          required:
            - year
            - month
            - day
          description: The day the usage took place
        value:
          type: number
          description: >-
            The updated value of product units consumed by the customer, for the
            product for given day
      required:
        - customerId
        - meterId
        - usageDate
        - value
    CreateMeasurementResponse:
      type: object
      properties:
        measurement:
          type: object
          properties:
            customerId:
              type: string
              pattern: ^[0-9a-fA-F]{24}$
              description: The customer for whom usage will be attributed
            meterId:
              type: string
              pattern: ^[0-9a-fA-F]{24}$
              description: The meter/product that is being measured
            usageDate:
              type: object
              properties:
                year:
                  type: integer
                  minimum: 0
                month:
                  type: integer
                  minimum: 0
                  maximum: 12
                day:
                  type: integer
                  minimum: 1
                  maximum: 31
              required:
                - year
                - month
                - day
              description: The day the usage took place
            value:
              type: number
              description: >-
                The updated value of product units consumed by the customer, for
                the product for given day
            id:
              type: string
            createdAt:
              type: string
              format: date-time
            updatedAt:
              type: string
              format: date-time
          required:
            - customerId
            - meterId
            - usageDate
            - value
            - id
            - createdAt
            - updatedAt
      required:
        - measurement
  securitySchemes:
    BearerAuthorizer:
      type: http
      scheme: bearer
      bearerFormat: JWT

````